import { useContext, useEffect } from 'react';

import { Modal, ModalContext } from './context';

export const useModal = <P>(modal?: Modal<P>) => {
	const { registered, close, open, opened, register, unregister } = useContext(ModalContext);

	useEffect(() => {
		if (modal) {
			register(modal);
			return () => unregister(modal.id);
		}
	}, []);

	return {
		modals: registered,
		opened: opened,
		openModal: open,
		closeModal: close,
		registerModal: register,
		unregisterModal: unregister,
	};
};
